/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplateReviewData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateReviewData{}

// TemplateReviewData struct for TemplateReviewData
type TemplateReviewData struct {
	Approved bool `json:"approved"`
}

// NewTemplateReviewData instantiates a new TemplateReviewData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateReviewData(approved bool) *TemplateReviewData {
	this := TemplateReviewData{}
	this.Approved = approved
	return &this
}

// NewTemplateReviewDataWithDefaults instantiates a new TemplateReviewData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateReviewDataWithDefaults() *TemplateReviewData {
	this := TemplateReviewData{}
	return &this
}

// GetApproved returns the Approved field value
func (o *TemplateReviewData) GetApproved() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Approved
}

// GetApprovedOk returns a tuple with the Approved field value
// and a boolean to check if the value has been set.
func (o *TemplateReviewData) GetApprovedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Approved, true
}

// SetApproved sets field value
func (o *TemplateReviewData) SetApproved(v bool) {
	o.Approved = v
}

func (o TemplateReviewData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateReviewData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["approved"] = o.Approved
	return toSerialize, nil
}

type NullableTemplateReviewData struct {
	value *TemplateReviewData
	isSet bool
}

func (v NullableTemplateReviewData) Get() *TemplateReviewData {
	return v.value
}

func (v *NullableTemplateReviewData) Set(val *TemplateReviewData) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateReviewData) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateReviewData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateReviewData(val *TemplateReviewData) *NullableTemplateReviewData {
	return &NullableTemplateReviewData{value: val, isSet: true}
}

func (v NullableTemplateReviewData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateReviewData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


